#if !defined(_ADATA_DMACORE_H)
#define _ADATA_DMACORE_H

#include "platform.h"
#include "device.h"

/*
** -----------------------------------------------------------
** Client DMA functions
*/

/* Returns TRUE if on error */
extern os_boolean
ADMXRC_EnqueueDma(
  DeviceContext* pDevCtx,
  DmaNode* dmanode,
  os_boolean must_start);

extern os_boolean
ADMXRC_SubmitDmaRemote(
  DeviceContext* pDevCtx,
  DmaNode* dmanode,
  os_uint32* pPagesPci,
  unsigned long pageLength,
  unsigned int pageBits,
  unsigned long offset,
  unsigned long max,
  os_uint32 local,
  unsigned long* spanned);

extern os_boolean
ADMXRC_SubmitDmaUsbd(
  DeviceContext* pDevCtx,
  DmaNode* dmanode,
  OS_USBD* usbd,
  unsigned long offset,
  unsigned long max,
  os_uint32 local,
  unsigned long* spanned);

extern os_boolean
ADMXRC_SubmitDmaUser(
  DeviceContext* pDevCtx,
  DmaNode* dmanode,
  void* user,
  unsigned long max,
  os_uint32 local,
  unsigned long* spanned);

extern void
ADMXRC_CollectDma(
  DeviceContext* pDevCtx,
  DmaNode* dmanode);

/* Returns TRUE on error */
extern os_boolean
ADMXRC_ContinueDma(
  DeviceContext* pDevCtx,
  DmaNode* dmanode);

/* Returns TRUE if successfully cancelled */
extern os_boolean
ADMXRC_CancelDma(
  DeviceContext* pDevCtx,
  DmaNode* dmanode);

/*
** End of client DMA functions
** -----------------------------------------------------------
*/

/*
** Called by device open/close handler
*/
extern void
ADMXRC_CleanupDma(
  DeviceContext* pDevCtx);

/*
** Called as a result of a DMA interrupt
*/
extern void
ADMXRC_DmaCompleted(
  DeviceContext* pDevCtx,
  unsigned char chan);

#endif
